//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#include <dshow.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
__fastcall TPlayForm::TPlayForm(TComponent* Owner)
    : TForm(Owner)
{
    //KeyPreview = true;
    //TrackBar->Enabled = false;
    ch_auto = false;
    ch_manu = false;
    vol_ch = false;
    State == ST_READY;
    pgb  = NULL;
    pmc  = NULL;
    pmex = NULL;
    pvw  = NULL;
    pmp  = NULL;
#ifdef USE_IBA
    pba  = NULL;
#endif    
}
//---------------------------------------------------------------------------
//DirectShow
bool __fastcall TPlayForm::MediaInit(void)
{
    HRESULT hr;

    MRate = 1.0;

    CoInitialize(NULL);
    hr = CoCreateInstance(CLSID_FilterGraph,
                          NULL,
                          CLSCTX_INPROC_SERVER,
                          IID_IGraphBuilder,
                          (void**)&pgb);
    if (FAILED(hr)) {
        return false;
    }
    hr = pgb->QueryInterface(IID_IMediaControl, (void**)&pmc);
    if (FAILED(hr)) {
        MediaClose();
        return false;
    }
    hr = pgb->QueryInterface(IID_IMediaEventEx, (void**)&pmex);
    if (FAILED(hr)) {
        MediaClose();
        return false;
    }
    hr = pgb->QueryInterface(IID_IVideoWindow, (void**)&pvw);
    if (FAILED(hr)) {
        MediaClose();
        return false;
    }
    hr = pgb->QueryInterface(IID_IMediaPosition, (void**)&pmp);
    if (FAILED(hr)) {
        MediaClose();
        return false;
    }
#ifdef USE_IBA
    hr = pgb->QueryInterface(IID_IBasicAudio, (void**)&pba);
    if (FAILED(hr)) {
        MediaClose();
        return false;
    }
#endif    
    return true;
}
//---------------------------------------------------------------------------
//fBAt@CJ
bool __fastcall TPlayForm::MediaOpen(void)
{
    HRESULT hr;
    hr = pgb->RenderFile(wFile, NULL);

    if (SUCCEEDED(hr)) return true;
    return false;
}
//---------------------------------------------------------------------------
//DirectShow̌n
void __fastcall TPlayForm::MediaClose(void)
{
    if (pvw) {
        pvw->put_Visible(OAFALSE);
        pvw->put_Owner(NULL);
        HELPER_RELEASE(pvw)
    }
#ifdef USE_IBA
    HELPER_RELEASE(pba);
#endif
    HELPER_RELEASE(pmp);
    HELPER_RELEASE(pmex);
    HELPER_RELEASE(pmc);
    HELPER_RELEASE(pgb);
    CoUninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::FormClose(TObject *Sender, TCloseAction &Action)
{
    State = ST_STOP;
    Visible = false;
    x1Click(x1); //Formʂłƃ^XNo[Ɏc
}
//---------------------------------------------------------------------------
//sb`ύX
void __fastcall TPlayForm::ChangeRate(void)
{
    if (MRate > 9.99) { //MAX 10.0
        MRate = 10.0;
    } else if (MRate < 0.1) { //MIN 0.1
        MRate = 0.1;
    }
    pmp->put_Rate(MRate);//sb`ύX
    pmp->get_Rate(&MRate);//ύX̃sb`擾
    StatusBar->Panels->Items[2]->Text = FormatFloat((AnsiString)"0.0", MRate);
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::FormKeyPress(TObject *Sender, char &Key)
{
    if (!pvw) return;
    switch (Key) {
        //case 'Q':
        //case 'q':
        case VK_ESCAPE:
            Close();
            break;
        case VK_SPACE:
        case VK_RETURN:
            if (State == ST_PLAY) {
                MediaClick(BTN_PAUSE);
            } else {
                MediaClick(BTN_PLAY);
            }
            break;
        case VK_BACK:
            MediaClick(BTN_PREV);
            break;
        case 'C':
        case 'c':
            x1Click(x1);
            break;
        case 'X':
        case 'x':
            x1Click(x2);
            break;
        case 'Z':
        case 'z':
            x1Click(x4);
            break;
        case 'V':
        case 'v':
            x1Click(xC);
            break;
        case 'B':
        case 'b':
            //putFullScreen();
            x1Click(xF);
            break;
        case 'A':
        case 'a':
            MRate = 1.0;
            ChangeRate();//sb`ύX
            break;
        case 'S':
        case 's':
            MRate += 0.1;
            ChangeRate();//sb`ύX
            break;
        case 'D':
        case 'd':
            MRate -= 0.1;
            ChangeRate();//sb`ύX
            break;
        case 'F':
        case 'f':
            MRate += 1.0; //ő͂...
            ChangeRate();//sb`ύX
            break;
        case 'G':
        case 'g':
            MRate = 0.1; //ŒxĂƂ
            ChangeRate();//sb`ύX
            break;
        case 'M':
        case 'm': //~[ggO
            MuteToggle();
            break;
        case ',': //< {[
            if (VolTB->Enabled)
                VolTB->Position -= 10;
            break;
        case '.': //> {[グ
            if (VolTB->Enabled)
                VolTB->Position += 10;
            break;
        default:
            ;
    }
    Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::MediaClick(int Button)
{
    switch (Button) {
        case BTN_PLAY:
            PlaySB->Enabled = false;
            PauseSB->Enabled = true;
            pmc->Run();
            State = ST_PLAY;
            break;
        case BTN_PAUSE:
            PlaySB->Enabled = true;
            PauseSB->Enabled = false;
            pmc->Pause();
            State = ST_PAUSE;
            break;
        case BTN_PREV:
            PlaySB->Enabled = true;
            PauseSB->Enabled = false;
            pmc->Pause();
            pmp->put_CurrentPosition(0.0);
            State = ST_PAUSE;
            break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::WMGraphNotify(TMessage &Msg)
{
    LONG evCode;
    LONG evParam1, evParam2;

    if (pmex == NULL) return;
    while ( SUCCEEDED( pmex->GetEvent( &evCode, &evParam1, &evParam2, 0 ) ) ) {
        pmex->FreeEventParams( evCode, evParam1, evParam2 );
        if ( evCode == EC_COMPLETE || evCode == EC_USERABORT || evCode == EC_ERRORABORT) {
            //ɏILq
            //State = ST_STOP;
            Close();
            break;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::Play(void)
{
    vol_ch = true;
#ifdef USE_IBA
    //0 ͍ő{[ŁA-10,000 ͖
    long vol;
    pba->get_Volume(&vol);
    VolTB->Position = pow(10.0, (double)vol/5000)*100.0;
#else
    volume.InitMixer(this->Handle);
    int vol;
    volume.GetMasterVolume(&vol);
    VolTB->Position = vol;
#endif
    vol_ch = false;

    State = ST_PLAY;
    pmc->Run();

    int timer = 0;
while (State == ST_PLAY || State == ST_PAUSE) {
    if (timer >= 4) {
        StatesTextUpdate();
        timer = 0;
    } else {
        timer++;
    }
    Sleep(50);
    Application->ProcessMessages();
}

}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::TrackBarChange(TObject *Sender)
{
    if (ch_auto) return;
    if (State == ST_STOP) return;

    ch_manu = true;

    REFTIME tpos = TrackBar->Position;
    pmp->put_CurrentPosition(tpos/1000);

    StatesTextUpdate();

    ch_manu = false;
}
//---------------------------------------------------------------------------
//ڐ̊ԊuύX
void __fastcall TPlayForm::sec10Click(TObject *Sender)
{
    int per_time = ((TMenuItem *)Sender)->Tag;
    TrackBar->Frequency = per_time;

    sec1->Checked  = false;
    sec10->Checked = false;
    sec30->Checked = false;
    min1->Checked  = false;
    min5->Checked  = false;
    min10->Checked = false;

    switch (per_time) {
        case TIME_01SEC:
            per = PER_01SEC;
            sec1->Checked   = true;
            break;
        case TIME_10SEC:
            per = PER_10SEC;
            sec10->Checked  = true;
            break;
        case TIME_30SEC:
            per = PER_30SEC;
            sec30->Checked  = true;
            break;
        case TIME_01MIN:
            per = PER_01MIN;
            min1->Checked   = true;
            break;
        case TIME_05MIN:
            per = PER_05MIN;
            min5->Checked   = true;
            break;
        case TIME_10MIN:
            per = PER_10MIN;
            min10->Checked  = true;
            break;
    }

    StatusBar->Panels->Items[1]->Text = per;
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::PlaySBClick(TObject *Sender)
{
    int Button;
#define PLAYBUTTON  0
#define PAUSEBUTTON 1
#define PREVBUTTON  2
    switch ( ((TSpeedButton *)Sender)->Tag ) {
        case PLAYBUTTON:
            Button = BTN_PLAY;
            break;
        case PAUSEBUTTON:
            Button = BTN_PAUSE;
            break;
        case PREVBUTTON:
            Button = BTN_PREV;
            break;
    }
    MediaClick(Button);
}
//---------------------------------------------------------------------------
//\{ύX
void __fastcall TPlayForm::x1Click(TObject *Sender)
{
    if (Scale->Enabled == false) return;

    RECT rc;
    int VWidth  = MWidth;
    int VHeight = MHeight;
    int MovieSize = ((TMenuItem *)Sender)->Tag;

    x1->Checked = false; // TCY1{
    x2->Checked = false; // TCY2{
    x4->Checked = false; // TCY4{
    xC->Checked = false; // JX^TCY
    xF->Checked = false; // tXN[

if (MovieSize == -1) { //tXN[
    VWidth  = Screen->DesktopWidth;
    VHeight = Screen->DesktopHeight;
} else {
    if (MovieSize == 0) { //JX^TCY
        VWidth  = ifmmvar.option[IFMMOPT_MovieWidth];
        VHeight = ifmmvar.option[IFMMOPT_MovieHeight];
    } else if (MovieSize != 1 /*P{*/) {
        VWidth  *= MovieSize;
        VHeight *= MovieSize;
        if ((VWidth > Screen->DesktopWidth) || (VHeight > Screen->DesktopHeight)) {
            //ʂ傫
            if (MovieSize == 4 /*S{*/) {
                x1Click(x2); //2{
            } else {
                x1Click(x1); //P{
            }
            return;
        }
    }
}
    ((TMenuItem *)Sender)->Checked = true;

    if (pvw) {
        pvw->put_Visible(OAFALSE);
        pvw->put_Owner(NULL);
        HELPER_RELEASE(pvw)
    }
    pgb->QueryInterface(IID_IVideoWindow, (void**)&pvw);

    TPoint p;
    p.x = MovieP->Left;
    p.y = MovieP->Top;
    p = ClientToScreen(p);
    int dh = p.y -Top;
    int dw = p.x -Left;
#define DEFAULT_WIDTH 276
    Visible = false;
    WindowState = wsNormal;
if (MovieSize == -1) { //tXN[
    FormStyle = fsStayOnTop; //őO
    BorderStyle = bsNone; //ȂƉ
    StatusBar->Visible = false;
    Panel->Visible = false;
    ClientWidth  = VWidth;
    ClientHeight = VHeight; //ɏk߂ꂿႤH
    GetCustomRect(&rc, ClientWidth, ClientHeight);
} else {
    BorderStyle = bsSizeable;
    if (ifmmvar.option[IFMMOPT_StayOnTop]) {
        FormStyle = fsStayOnTop;
    } else {
        FormStyle = fsNormal;
    }
    StatusBar->Visible = true;
    Panel->Visible = true;
    Width  = (VWidth < DEFAULT_WIDTH)? DEFAULT_WIDTH: VWidth +dw*2;
    Height =  VHeight +Panel->Height +StatusBar->Height +dh;
if (MovieSize == 0) { //JX^TCY
    GetCustomRect(&rc, ifmmvar.option[IFMMOPT_MovieWidth], ifmmvar.option[IFMMOPT_MovieHeight]);
} else {
    ::GetClientRect(ScrollBox->Handle, &rc);
    if (VWidth < DEFAULT_WIDTH) { //悪ꍇɕ\
        GetCustomRect(&rc, rc.right -rc.left, rc.bottom -rc.top);
    }
}
}
    SetMovieRect(&rc);

    //EBhEʒu
if (MovieSize == -1) { //tXN[
    Top  = Screen->DesktopTop;// -dh;
    Left = Screen->DesktopLeft;// -dw;
} else if (MovieSize == 0) { //JX^TCY
        Top  = ifmmvar.option[IFMMOPT_MoviePosY];
        Left = ifmmvar.option[IFMMOPT_MoviePosX];
} else {
    if (Screen->DesktopHeight < Height || Screen->DesktopWidth < Width) {
        //ʂ傫
        Top  = Screen->DesktopTop;
        Left = Screen->DesktopLeft;
    } else {
        //ʂ͂ݏoĂȂ璲
        if (Screen->DesktopTop > Top) { //
            Top = Screen->DesktopTop;
        } else
        if ((Screen->DesktopTop +Screen->DesktopHeight) < (Top +Height)) { //
            Top = Screen->DesktopTop +(Screen->DesktopHeight -Height)/2;
        }
        if (Screen->DesktopLeft > Left) { //
            Left = Screen->DesktopLeft;
        } else
        if ((Screen->DesktopLeft +Screen->DesktopWidth) < (Left +Width)) { //E
            Left = Screen->DesktopLeft +(Screen->DesktopWidth -Width)/2;
        }
    }

    if (ifmmvar.option[IFMMOPT_MovieCenter]) { //JX^TCY̓Z^[w𖳎
        Top  = Screen->DesktopTop  +(Screen->DesktopHeight -Height) /2;
        Left = Screen->DesktopLeft +(Screen->DesktopWidth  -Width)  /2;
    }
}

    //EBhEnhςĂ̂ōēo^
    pvw->put_Owner((OAHWND)ScrollBox->Handle);
    pvw->put_WindowStyle(WS_CHILD|WS_CLIPSIBLINGS|WS_CLIPCHILDREN);
    pvw->put_Visible(OATRUE);
    pvw->put_MessageDrain((OAHWND)ScrollBox->Handle);
    pmex->SetNotifyWindow((OAHWND)Handle, WM_GRAPHNOTIFY, 0);
    if (State == ST_STOP) return;
#ifndef USE_IBA
    volume.ReleaseMixer();
    volume.InitMixer(this->Handle);
#endif
    Visible = true;
}
//---------------------------------------------------------------------------
//gpȂ
void __fastcall TPlayForm::putFullScreen(void)
{
    if (Scale->Enabled == false) return;

    FormStyle = fsNormal; //őOʉ
    pvw->put_MessageDrain((OAHWND)ScrollBox->Handle);
    pmex->SetNotifyWindow((OAHWND)Handle, WM_GRAPHNOTIFY, 0);
    pvw->put_FullScreenMode(OATRUE);
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::StatesTextUpdate(void)
{
    REFTIME pos;
    pmp->get_CurrentPosition(&pos);
    pos *= 1000; //~bPʂ
    ch_auto = true;
    if (!ch_manu) TrackBar->Position = pos;
    ch_auto = false;
    int min = pos / (1000*60);
    int sec = (pos -min * (1000*60) )/1000;
    StatusBar->Panels->Items[0]->Text = FormatFloat("00", min) +"F"
            +FormatFloat("00", sec) +" / " +length;

    if (lpPrgressCallback != NULL)
        if (lpPrgressCallback(pos, TheLength, lData)) {
            State = ST_ABORT;
        }
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::ScrollBoxClick(TObject *Sender)
{
    if (State == ST_PLAY) {
        MediaClick(BTN_PAUSE);
    } else {
        MediaClick(BTN_PLAY);
    }
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::FormResizeEx(TObject *Sender)
{
    AnsiString xy = "W, H = ";
    xy += (AnsiString)(MovieP->Width -2) +", " +(AnsiString)(MovieP->Height -2);
    StatusBar->Panels->Items[0]->Text = xy;
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::SetMovieRect(RECT *prc)
{
    pvw->SetWindowPosition(prc->left, prc->top, prc->right, prc->bottom);
    TrackBar->Width = ClientWidth -TrackBar->Left;
    VolTB->Left = ClientWidth -VolTB->Width -14;
    StatusBar->Panels->Items[0]->Width = ClientWidth
       -50 -30;
       //-StatusBar1->Panels->Items[1]->Width -StatusBar1->Panels->Items[2]->Width;
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::GetCustomRect(RECT *prc, int cwidth, int cheight)
{
    double xrate, yrate;
    int xsize, ysize;

    xrate = cwidth  / (double)MWidth;
    yrate = cheight / (double)MHeight;
    if (xrate > yrate) xrate = yrate; //䗦ɍ킹

    xsize = MWidth  * xrate;
    ysize = MHeight * xrate;
    prc->left   = (cwidth  - xsize) /2;
    prc->top    = (cheight - ysize) /2;
    prc->right  = xsize;
    prc->bottom = ysize;
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::FormResizeMovie(TObject *Sender)
{
    RECT rc;
    int w, h;
    w = MovieP->Width  -2;
    h = MovieP->Height -2;
    GetCustomRect(&rc, w, h);
    SetMovieRect(&rc);
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::VolTBChange(TObject *Sender)
{
    VolTB->SelEnd = VolTB->Position;
    if (vol_ch) return;
    ChangeVolume(VolTB->Position);
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::ChangeVolume(int vol)
{
#ifdef USE_IBA
    if (!pba) return;
    //0 ͍ő{[ŁA-10,000 ͖
    pba->put_Volume(log10(vol/100.0)*5000); //ΐڐ...
#else
    //0(min)A100(max)
    volume.SetMasterVolume(vol);
#endif
}
//---------------------------------------------------------------------------
inline void __fastcall TPlayForm::MuteToggle()
{
#ifdef USE_IBA
    return;
#else
    volume.ReverseMasterMute();
#endif
}
//---------------------------------------------------------------------------
void __fastcall TPlayForm::MM_MixCtrChange(TMessage &Msg)
{
#ifdef USE_IBA
    return;
#else
    if (pgb == NULL) return;

    //hMixer = Msg.WParam
    //dwControlID = Msg.LParam;
    //蔲
    int vol;
    volume.GetMasterVolume(&vol);
    vol_ch = true;
    VolTB->Position = vol;
    vol_ch = false;
    bool mute;
    volume.GetMasterMute(&mute);
    VolTB->Enabled = !mute;
#endif
}
//---------------------------------------------------------------------------

